#include <windows.h>

#pragma comment(linker, "/SECTION:.shared,RWS")
#pragma data_seg(".shared")
HHOOK hHook = NULL;
HWND hHostWnd = NULL;
HINSTANCE hInstance = NULL;
UINT hHostWndMsg = 0;
UINT hook_type = WH_CALLWNDPROC;
UINT target_tid = 0;
static DWORD dwTargetProcessId = 0;
#pragma data_seg()

#define WMHOOK_API __declspec(dllexport)

WMHOOK_API BOOL APIENTRY wm_hook(HWND hWnd, UINT msg);
WMHOOK_API BOOL APIENTRY wm_unhook();
LRESULT CALLBACK HookProc(int nCode, WPARAM wParam, LPARAM lParam);

BOOL WINAPI DllMain(HINSTANCE hInstDLL, DWORD fdwReason, LPVOID lpReserved)
{
	if(fdwReason == DLL_PROCESS_ATTACH) 
		hInstance = hInstDLL;
	return TRUE;
}

WMHOOK_API BOOL APIENTRY wm_hook(HWND hWnd, UINT msg)
{
	if(hHook != NULL && wm_unhook() == FALSE) return FALSE;

	hHook = SetWindowsHookEx(hook_type, HookProc, hInstance, target_tid);
	if (hHook == NULL) return FALSE;

	hHostWnd = hWnd;
	hHostWndMsg = msg;

	return TRUE;
}

WMHOOK_API void APIENTRY wm_settype(UINT _hook_type)
{
	hook_type = _hook_type;
}

WMHOOK_API void APIENTRY wm_settid(UINT _tid)
{
	target_tid = _tid;
}

WMHOOK_API void APIENTRY wm_setpid(UINT _pid)
{
	dwTargetProcessId = _pid;
}

WMHOOK_API BOOL APIENTRY wm_unhook()
{
	if(hHook != NULL && UnhookWindowsHookEx(hHook))
	{
		hHook = NULL;
		return TRUE;
	}
	return FALSE;
}

LRESULT CALLBACK HookProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	LRESULT ret = CallNextHookEx(hHook, nCode, wParam, lParam);
	DWORD dwPid = GetCurrentProcessId();
	if (dwTargetProcessId == dwPid) {
		if(nCode == HC_ACTION)
			ret |= SendMessage(hHostWnd, hHostWndMsg, wParam, lParam);
	}
	return ret;
}

